Example #1
0
        public IModel GetModelByWhereSql(string whereSql)
        {
            string sql =
                "select LKSSPECId,ModuleTreeId,Length,Height,WBeam,SidePanel,LightType,Japan from LKSSPEC";

            sql += whereSql;
            SqlDataReader objReader = SQLHelper.GetReader(sql);
            LKSSPEC       objModel  = null;

            if (objReader.Read())
            {
                objModel = new LKSSPEC()
                {
                    LKSSPECId    = Convert.ToInt32(objReader["LKSSPECId"]),
                    ModuleTreeId = Convert.ToInt32(objReader["ModuleTreeId"]),
                    //最好不要用=null去判断,提示类型转换错误
                    Length    = objReader["Length"].ToString().Length == 0 ? 0 : Convert.ToDecimal(objReader["Length"]),
                    Height    = objReader["Height"].ToString().Length == 0 ? 0 : Convert.ToDecimal(objReader["Height"]),
                    WBeam     = objReader["WBeam"].ToString().Length == 0 ? "" : objReader["WBeam"].ToString(),
                    SidePanel = objReader["SidePanel"].ToString().Length == 0 ? "" : objReader["SidePanel"].ToString(),
                    LightType = objReader["LightType"].ToString().Length == 0 ? "" : objReader["LightType"].ToString(),
                    Japan     = objReader["Japan"].ToString().Length == 0 ? "" : objReader["Japan"].ToString(),
                };
            }
            objReader.Close();
            return(objModel);
        }
Example #2
0
        public int EditModel(IModel model)
        {
            LKSSPEC objModel = (LKSSPEC)model;
            //编写带参数的SQL语句
            StringBuilder sqlBuilder = new StringBuilder();

            sqlBuilder.Append("Update LKSSPEC set Length=@Length,Height=@Height,WBeam=@WBeam,SidePanel=@SidePanel,LightType=@LightType,Japan=@Japan where LKSSPECId=@LKSSPECId");
            //定义参数数组
            SqlParameter[] param = new SqlParameter[]
            {
                new SqlParameter("@Length", objModel.Length),
                new SqlParameter("@Height", objModel.Height),
                new SqlParameter("@WBeam", objModel.WBeam),
                new SqlParameter("@SidePanel", objModel.SidePanel),
                new SqlParameter("@LightType", objModel.LightType),
                new SqlParameter("@Japan", objModel.Japan),

                new SqlParameter("@LKSSPECId", objModel.LKSSPECId)
            };
            try
            {
                return(SQLHelper.Update(sqlBuilder.ToString(), param));
            }
            catch (SqlException ex)
            {
                throw new Exception("数据库操作出现异常:" + ex.Message);
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
Example #3
0
        public FrmLKSSPEC(Drawing drawing, ModuleTree tree) : this()
        {
            objLKSSPEC = (LKSSPEC)objLKSSPECService.GetModelByModuleTreeId(tree.ModuleTreeId.ToString());
            if (objLKSSPEC == null)
            {
                return;
            }
            this.Text = drawing.ODPNo + " / Item: " + drawing.Item + " / Module: " + tree.Module + " - " + tree.CategoryName;
            Category objCategory = objCategoryService.GetCategoryByCategoryId(tree.CategoryId.ToString());

            pbModelImage.Image = objCategory.ModelImage.Length == 0
                ? Image.FromFile("NoPic.png")
                : (Image) new SerializeObjectToString().DeserializeObject(objCategory.ModelImage);
            FillData();
        }
Example #4
0
        public void AutoDrawing(SldWorks swApp, ModuleTree tree, string projectPath)
        {
            //创建项目模型存放地址
            string itemPath = projectPath + @"\" + tree.Module + "-" + tree.CategoryName;

            if (!Directory.Exists(itemPath))
            {
                Directory.CreateDirectory(itemPath);
            }
            else
            {
                DialogResult result =
                    MessageBox.Show("模型文件夹" + itemPath + "存在,如果之前pack已经执行过,将不执行pack过程而是直接修改模型,如果要继续请点击YES,否请点击No中断作图", "提示信息",
                                    MessageBoxButtons.YesNo);
                if (result == DialogResult.No)
                {
                    return;
                }
            }
            //Pack的后缀
            string suffix = tree.Module + "-" + tree.ODPNo.Substring(tree.ODPNo.Length - 6);
            //判断文件是否存在,如果存在将不执行pack,如果不存在则执行pack
            //packango后需要接收打包完成的地址,参数为后缀
            string packedAssyPath = itemPath + @"\" + tree.CategoryName.ToLower() + "_" + suffix + ".sldasm";

            if (!File.Exists(packedAssyPath))
            {
                packedAssyPath = CommonFunc.PackAndGoFunc(suffix, swApp, tree.ModelPath, itemPath);
            }

            //查询参数
            LKSSPEC item = (LKSSPEC)objLKSSPECService.GetModelByModuleTreeId(tree.ModuleTreeId.ToString());

            swApp.CommandInProgress = true; //告诉SolidWorks,现在是用外部程序调用命令
            int warnings = 0;
            int errors   = 0;

            suffix = "_" + suffix;//后缀
            ModelDoc2         swModel = default(ModelDoc2);
            ModelDoc2         swPart  = default(ModelDoc2);
            AssemblyDoc       swAssy  = default(AssemblyDoc);
            Component2        swComp;
            Feature           swFeat        = default(Feature);
            object            configNames   = null;
            ModelDocExtension swModelDocExt = default(ModelDocExtension);
            bool   status     = false;
            string compReName = string.Empty;

            //打开Pack后的模型
            swModel = swApp.OpenDoc6(packedAssyPath, (int)swDocumentTypes_e.swDocASSEMBLY,
                                     (int)swOpenDocOptions_e.swOpenDocOptions_Silent, "", ref errors, ref warnings) as ModelDoc2;
            swAssy = swModel as AssemblyDoc;                                                  //装配体
            string assyName = swModel.GetTitle().Substring(0, swModel.GetTitle().Length - 7); //获取装配体名称

            swModelDocExt = (ModelDocExtension)swModel.Extension;
            //打开装配体后必须重建,使Pack后的零件名都更新到带后缀的状态,否则程序出错
            swModel.ForceRebuild3(true);
            //TopOnly参数设置成true,只重建顶层,不重建零件内部

            /*注意SolidWorks单位是m,计算是应当/1000m
             * 整形与整形运算得出的结果仍然时整形,1640 / 1000m结果为0,因此必须将其中一个转化成decimal型,使用后缀m就可以了
             * (int)不进行四舍五入,Convert.ToInt32会四舍五入
             */
            //-----------计算中间值,----------

            try
            {
                //----------Top Level----------
                //----------侧板----------
                switch (item.SidePanel)
                {
                case "LEFT":
                case "RIGHT":
                    //重命名装配体内部
                    compReName = "FNCL0018[LKEC-" + tree.Module + "]{255}(" + (int)(item.Height - 5m) + ")";
                    status     = swModelDocExt.SelectByID2(CommonFunc.AddSuffix(suffix, "FNCL0018[LKEC-]{255}()-1") + "@" + assyName, "COMPONENT", 0, 0, 0, false, 0, null, 0);
                    if (status)
                    {
                        swModelDocExt.RenameDocument(compReName);
                    }
                    swModel.ClearSelection2(true);
                    status = swModelDocExt.SelectByID2(compReName + "-1" + "@" + assyName, "COMPONENT", 0, 0, 0, false, 0, null, 0);
                    swModel.ClearSelection2(true);
                    if (status)
                    {
                        swComp = swAssy.GetComponentByName(compReName + "-1");
                        swComp.SetSuppression2(2);      //2解压缩,0压缩.
                        swPart = swComp.GetModelDoc2(); //打开零件
                        swPart.Parameter("D1@Sketch1").SystemValue = (item.Height - 5m) / 1000m;
                        swComp = swAssy.GetComponentByName(compReName + "-2");
                        swComp.SetSuppression2(0);     //2解压缩,0压缩.
                    }
                    swComp = swAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "FNCL0016[LKRPS]{80}-1"));
                    swComp.SetSuppression2(2);     //2解压缩,0压缩.
                    swComp = swAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "FNCL0016[LKRPS]{80}-2"));
                    swComp.SetSuppression2(2);     //2解压缩,0压缩.
                    swComp = swAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "FNCL0017[LKRPT]{250}-1"));
                    swComp.SetSuppression2(2);     //2解压缩,0压缩.
                    break;

                case "MIDDLE":
                    //重命名装配体内部
                    compReName = "FNCL0018[LKEC-" + tree.Module + "]{255}(" + (int)(item.Height - 5m) + ")";
                    status     = swModelDocExt.SelectByID2(compReName + "-1" + "@" + assyName, "COMPONENT", 0, 0, 0, false, 0, null, 0);
                    swModel.ClearSelection2(true);
                    if (status)
                    {
                        swComp = swAssy.GetComponentByName(compReName + "-1");
                        swComp.SetSuppression2(0);     //2解压缩,0压缩.
                        swComp = swAssy.GetComponentByName(compReName + "-2");
                        swComp.SetSuppression2(0);     //2解压缩,0压缩.
                    }
                    else
                    {
                        swComp = swAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "FNCL0018[LKEC-]{255}()-1"));
                        swComp.SetSuppression2(0);     //2解压缩,0压缩.
                        swComp = swAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "FNCL0018[LKEC-]{255}()-2"));
                        swComp.SetSuppression2(0);     //2解压缩,0压缩.
                    }
                    swComp = swAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "FNCL0016[LKRPS]{80}-1"));
                    swComp.SetSuppression2(2);     //2解压缩,0压缩.
                    swComp = swAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "FNCL0016[LKRPS]{80}-2"));
                    swComp.SetSuppression2(2);     //2解压缩,0压缩.
                    swComp = swAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "FNCL0017[LKRPT]{250}-1"));
                    swComp.SetSuppression2(2);     //2解压缩,0压缩.
                    break;

                default:
                    //重命名装配体内部
                    compReName = "FNCL0018[LKEC-" + tree.Module + "]{255}(" + (int)(item.Height - 5m) + ")";
                    status     = swModelDocExt.SelectByID2(CommonFunc.AddSuffix(suffix, "FNCL0018[LKEC-]{255}()-1") + "@" + assyName, "COMPONENT", 0, 0, 0, false, 0, null, 0);
                    if (status)
                    {
                        swModelDocExt.RenameDocument(compReName);
                    }
                    swModel.ClearSelection2(true);
                    status = swModelDocExt.SelectByID2(compReName + "-1" + "@" + assyName, "COMPONENT", 0, 0, 0, false, 0, null, 0);
                    swModel.ClearSelection2(true);
                    if (status)
                    {
                        swComp = swAssy.GetComponentByName(compReName + "-1");
                        swComp.SetSuppression2(2);      //2解压缩,0压缩.
                        swPart = swComp.GetModelDoc2(); //打开零件
                        swPart.Parameter("D1@Sketch1").SystemValue = (item.Height - 5m) / 1000m;
                        swComp = swAssy.GetComponentByName(compReName + "-2");
                        swComp.SetSuppression2(2);     //2解压缩,0压缩.
                    }
                    swComp = swAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "FNCL0016[LKRPS]{80}-1"));
                    swComp.SetSuppression2(0);     //2解压缩,0压缩.
                    swComp = swAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "FNCL0016[LKRPS]{80}-2"));
                    swComp.SetSuppression2(0);     //2解压缩,0压缩.
                    swComp = swAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "FNCL0017[LKRPT]{250}-1"));
                    swComp.SetSuppression2(0);     //2解压缩,0压缩.
                    break;
                }


                //----------灯腔主体----------
                //重命名装配体内部
                compReName = "FNCL0015[LKSSPEC-" + tree.Module + "]{" + (int)item.Length + "}";
                status     = swModelDocExt.SelectByID2(CommonFunc.AddSuffix(suffix, "FNCL0015-1") + "@" + assyName, "COMPONENT", 0, 0, 0, false, 0, null, 0);
                if (status)
                {
                    swModelDocExt.RenameDocument(compReName);
                }
                swModel.ClearSelection2(true);
                status = swModelDocExt.SelectByID2(compReName + "-1" + "@" + assyName, "COMPONENT", 0, 0, 0, false, 0, null, 0);
                swModel.ClearSelection2(true);
                if (status)
                {
                    swComp = swAssy.GetComponentByName(compReName + "-1");
                    swPart = swComp.GetModelDoc2(); //打开零件
                    swPart.Parameter("D2@Skizze1").SystemValue       = item.Length / 1000m;
                    swPart.Parameter("D7@Kante-Lasche1").SystemValue = item.Height / 1000m;
                    //swFeat = swComp.FeatureByName("Cut-Extrude2");
                    //if (item.Japan == "YES") swFeat.SetSuppression2(0, 2, configNames); //参数1:1解压,0压缩
                    //else swFeat.SetSuppression2(1, 2, configNames); //参数1:1解压,0压缩
                    //swFeat = swComp.FeatureByName("JAP LED M8");
                    //if (item.Japan == "YES") swFeat.SetSuppression2(1, 2, configNames); //参数1:1解压,0压缩
                    //else swFeat.SetSuppression2(0, 2, configNames); //参数1:1解压,0压缩
                    swFeat = swComp.FeatureByName("LIGHT T8");
                    if (item.LightType == "T8")
                    {
                        swFeat.SetSuppression2(1, 2, configNames);                         //参数1:1解压,0压缩
                    }
                    else
                    {
                        swFeat.SetSuppression2(0, 2, configNames);  //参数1:1解压,0压缩
                    }
                    //if (item.WBeam == "YES")
                    //{
                    //    swFeat = swComp.FeatureByName("Cut-Extrude3");
                    //    swFeat.SetSuppression2(1, 2, configNames);
                    //    swFeat = swComp.FeatureByName("Cut-Extrude4");
                    //    swFeat.SetSuppression2(1, 2, configNames);
                    //    swFeat = swComp.FeatureByName("Unfold1");
                    //    swFeat.SetSuppression2(1, 2, configNames);
                    //    swFeat = swComp.FeatureByName("Cut-Extrude5");
                    //    swFeat.SetSuppression2(1, 2, configNames);
                    //    swFeat = swComp.FeatureByName("Fold1");
                    //    swFeat.SetSuppression2(1, 2, configNames);
                    //}
                    //else
                    //{
                    //    swFeat = swComp.FeatureByName("Cut-Extrude3");
                    //    swFeat.SetSuppression2(0, 2, configNames);
                    //    swFeat = swComp.FeatureByName("Cut-Extrude4");
                    //    swFeat.SetSuppression2(0, 2, configNames);
                    //    swFeat = swComp.FeatureByName("Unfold1");
                    //    swFeat.SetSuppression2(0, 2, configNames);
                    //    swFeat = swComp.FeatureByName("Cut-Extrude5");
                    //    swFeat.SetSuppression2(0, 2, configNames);
                    //    swFeat = swComp.FeatureByName("Fold1");
                    //    swFeat.SetSuppression2(0, 2, configNames);
                    //}
                }
                if (item.Japan == "YES")
                {
                    swComp = swAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "FNCE0070-1"));
                    swComp.SetSuppression2(0);                 //2解压缩,0压缩.
                    swFeat = swAssy.FeatureByName("LocalLPattern1");
                    swFeat.SetSuppression2(0, 2, configNames); //参数1:1解压,0压缩
                }
                else
                {
                    swComp = swAssy.GetComponentByName(CommonFunc.AddSuffix(suffix, "FNCE0070-1"));
                    swComp.SetSuppression2(2);                 //2解压缩,0压缩.
                    swFeat = swAssy.FeatureByName("LocalLPattern1");
                    swFeat.SetSuppression2(1, 2, configNames); //参数1:1解压,0压缩
                }

                swModel.ForceRebuild3(true);    //设置成true,直接更新顶层,速度很快,设置成false,每个零件都会更新,很慢
                swModel.Save();                 //保存,很耗时间
                swApp.CloseDoc(packedAssyPath); //关闭,很快
            }
            catch (Exception ex)
            {
                throw new Exception(packedAssyPath + "作图过程发生异常,详细:" + ex.Message);
            }
            finally
            {
                swApp.CommandInProgress = false; //及时关闭外部命令调用,否则影响SolidWorks的使用
            }
        }
Example #5
0
        private void btnEditData_Click(object sender, EventArgs e)
        {
            #region 数据验证
            //必填项目
            if (pbModelImage.Tag.ToString().Length == 0)
            {
                return;
            }
            if (!DataValidate.IsDecimal(txtLength.Text.Trim()) || Convert.ToDecimal(txtLength.Text.Trim()) < 100m)
            {
                MessageBox.Show("请认真检查灯腔长度", "提示信息");
                txtLength.Focus();
                txtLength.SelectAll();
                return;
            }
            if (!DataValidate.IsDecimal(txtHeight.Text.Trim()) || Convert.ToDecimal(txtHeight.Text.Trim()) < 20m)
            {
                MessageBox.Show("请认真检查灯腔高度", "提示信息");
                txtHeight.Focus();
                txtHeight.SelectAll();
                return;
            }
            //侧板
            if (cobWBeam.SelectedIndex == -1)
            {
                MessageBox.Show("请选择是否为水洗烟罩", "提示信息");
                cobWBeam.Focus();
                return;
            }
            if (cobSidePanel.SelectedIndex == -1)
            {
                MessageBox.Show("请选择是灯腔侧板", "提示信息");
                cobSidePanel.Focus();
                return;
            }
            //其他配置
            if (cobLightType.SelectedIndex == -1)
            {
                MessageBox.Show("请选择灯具类型", "提示信息");
                cobLightType.Focus();
                return;
            }
            if (cobJapan.SelectedIndex == -1)
            {
                MessageBox.Show("请选择是否为日本项目", "提示信息");
                cobJapan.Focus();
                return;
            }


            #endregion
            //封装对象
            LKSSPEC objLKSSPEC = new LKSSPEC()
            {
                LKSSPECId = Convert.ToInt32(pbModelImage.Tag),

                WBeam     = cobWBeam.Text,
                SidePanel = cobSidePanel.Text,
                LightType = cobLightType.Text,
                Japan     = cobJapan.Text,
                Length    = Convert.ToDecimal(txtLength.Text.Trim()),
                Height    = Convert.ToDecimal(txtHeight.Text.Trim())
            };
            //提交修改
            try
            {
                if (objLKSSPECService.EditModel(objLKSSPEC) == 1)
                {
                    MessageBox.Show("制图数据修改成功", "提示信息");
                    this.DialogResult = DialogResult.OK;
                    this.Close();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }